format compact;  format longe; close all; 


nex=nel; ney=nel;  % nel x nel squares, each w/ two triangles

E=2*nex*ney; % Number of triangles;
nv=6;        % Quadratic triangles.
nv=3;        % Linear triangles.

if nv==3; nxp=1*nex+1; nyp=1*ney+1; end;
if nv==6; nxp=2*nex+1; nyp=2*ney+1; end;
k=3; if nv==3; k=2; end;

glob=zeros(nv,E); xL=glob; yL=glob;

e=0;
for ey=1:ney; for ex=1:nex; 
   i0 = 2*(ex-1)-1; j0 = 2*(ey-1)-1;

   e=e+1;         % LOWER TRIANGLE; (verts, then edges, cclockwise)
     glob(1,e)=i0+1 + nxp*(j0+1);  xL(1,e)=i0+1; yL(1,e)=j0+1;
     glob(2,e)=i0+k + nxp*(j0+1);  xL(2,e)=i0+k; yL(2,e)=j0+1;
     glob(3,e)=i0+1 + nxp*(j0+k);  xL(3,e)=i0+1; yL(3,e)=j0+k;
     if nv==6;
       glob(4,e)=i0+2 + nxp*(j0+1);  xL(4,e)=i0+2; yL(4,e)=j0+1;
       glob(5,e)=i0+2 + nxp*(j0+2);  xL(5,e)=i0+2; yL(5,e)=j0+2;
       glob(6,e)=i0+1 + nxp*(j0+2);  xL(6,e)=i0+1; yL(6,e)=j0+2;
     end;

   e=e+1;         % UPPER TRIANGLE; (verts, then edges, cclockwise)
     glob(1,e)=i0+1 + nxp*(j0+k);  xL(1,e)=i0+1; yL(1,e)=j0+k;
     glob(2,e)=i0+k + nxp*(j0+1);  xL(2,e)=i0+k; yL(2,e)=j0+1;
     glob(3,e)=i0+k + nxp*(j0+k);  xL(3,e)=i0+k; yL(3,e)=j0+k;
     if nv==6;
        glob(4,e)=i0+2 + nxp*(j0+2);  xL(4,e)=i0+2; yL(4,e)=j0+2;
        glob(5,e)=i0+3 + nxp*(j0+2);  xL(5,e)=i0+3; yL(5,e)=j0+2;
        glob(6,e)=i0+2 + nxp*(j0+3);  xL(6,e)=i0+2; yL(6,e)=j0+3;
     end;

end;end;
glob=glob+1;
xL=xL/max(max(xL)); yL=yL/max(max(yL));
t=glob';

%%% Distort Geometry: theta=[y]; r=1+x;
%%% rL=1+xL;
%%% tL=pi*yL/2;
%%% xL = rL.*cos(tL);
%%% yL = rL.*sin(tL);



%% Set Local Mask

ML=1+0*glob; % ML=local mask
e=0; for ey=1:ney; for ex=1:nex; 
  i0 = 2*(ex-1); j0 = 2*(ey-1);
  if nv==6;
   e=e+1;         % LOWER TRIANGLE; (verts, then edges, cclockwise)
     if ex==1;   ML(1,e)=0; ML(3,e)=0; ML(6,e)=0; end;
     if ex==nex; ML(2,e)=0;                       end;
   e=e+1;         % UPPER TRIANGLE; (verts, then edges, cclockwise)
     if ex==1;   ML(1,e)=0;                       end;
     if ex==nex; ML(2,e)=0; ML(3,e)=0; ML(5,e)=0; end;
  else;
   e=e+1;         % LOWER TRIANGLE; (verts, then edges, cclockwise)
     if ex==1;   ML(1,e)=0; ML(3,e)=0; end;
     if ex==nex; ML(2,e)=0;            end;
   e=e+1;         % UPPER TRIANGLE; (verts, then edges, cclockwise)
     if ex==1;   ML(1,e)=0;            end;
     if ex==nex; ML(2,e)=0; ML(3,e)=0; end;
  end;
end;end;

n=2;
x=0:n; x=x'; y=x;
[RR,SS]=ndgrid(x,y);

for j=1:(n+1); jm=(n+1)-j;
    RR(:,j)=min(RR(:,j),jm)/n;
    SS(j,:)=min(SS(j,:),jm)/n;
end;
n1=n+1;
r=reshape(RR,n1*n1,1); s=reshape(SS,n1*n1,1); phi_f=zeros(n1*n1,nv);
for k=1:nv;
  if nv==3; phi_f(:,k)=basis_tri1(r,s,k); end;
  if nv==6; phi_f(:,k)=basis_tri2(r,s,k); end;
end;

%% Solve Poisson Equation

%
%  First, set up quadrature points and geometric factors
%
M=4; 
if nv>3; M=6; end; % 8 is Max allowable for trigausspoints

[z,w]=trigausspoints(M); r=z(:,1);s=z(:,2);

nq=length(r); Dr=zeros(nq,nv); Ds=Dr;
for k=1:nv; 
  if nv > 3;
   [Dr(:,k) Ds(:,k)]=basis_deriv2(r,s,k);  % Differentiate to fine mesh
    Jf(:,k)         =basis_tri2  (r,s,k);  % Interpolate to fine mesh
  else;
   [Dr(:,k) Ds(:,k)]=basis_deriv1(r,s,k);  % Differentiate to fine mesh
    Jf(:,k)         =basis_tri1  (r,s,k);  % Interpolate to fine mesh
  end;
end;

Xr = Dr*xL; Yr = Dr*yL;
Xs = Ds*xL; Ys = Ds*yL;

Jac = Xr.*Ys - Xs.*Yr; Jmin =min(min(Jac)); Jmax =max(max(Jac));
                       if Jmin <= 0; 'vanishing Jacobian' , break; end;
Rx  = Ys ./ Jac; Ry = -Xs ./ Jac;
Sy  = Xr ./ Jac; Sx = -Yr ./ Jac;


%% Build local stiffness matrices

D  = [Dr ; Ds ];  
AL = zeros(nv,nv,E); BL=AL;

for e=1:E;

   Be = w.*Jac(:,e);

   Grr = Rx(:,e).*Be.*Rx(:,e) + Ry(:,e).*Be.*Ry(:,e);
   Grs = Rx(:,e).*Be.*Sx(:,e) + Ry(:,e).*Be.*Sy(:,e);
   Gss = Sx(:,e).*Be.*Sx(:,e) + Sy(:,e).*Be.*Sy(:,e);

   Grr = diag(Grr); Grs = diag(Grs); Gss = diag(Gss);

   G = [ Grr Grs ; Grs Gss ];

   AL(:,:,e) = D'*G*D;
   BL(:,:,e) = Jf'*diag(Be)*Jf;

%  full(AL(:,:,e)), pause

end;
Abar=assemble_mat(AL,glob);

% Build restriction matrix from mask:

wcount = 1 + 0*xL; wcount = 1./loc2glob(wcount,glob);
mask = wcount .* loc2glob(ML,glob);

nb = length(mask);
n = sum(mask);  % Number of interior points
[n nb];

R = sparse([],[],[],n,nb,n);
i=0;
for j=1:nb;
  if mask(j) > 0; i=i+1; R(i,j)=1; end;
end;


A = R*Abar*R';



fL = 1 + 0*xL;   % f is prescribed in LOCAL coordinates only.
for e=1:E;
   BfL(:,e) = BL(:,:,e)*fL(:,e);
end;
rhs = loc2glob(BfL,glob);

ub = R' * (A \ (R*rhs));
uL = glob2loc(ub,glob);

hold off;

c= 3 / (4*log(2));
b= 1 / 4;

Emax=0;
hold off
for e=1:E;
   x=phi_f*xL(:,e); y=phi_f*yL(:,e);
   u=phi_f*uL(:,e);
   X=reshape(x,n1,n1);
   Y=reshape(y,n1,n1);
   U=reshape(u,n1,n1);
   rr=sqrt(X.*X+Y.*Y);
   Ue=.25*(1-rr.*rr) + c*log(rr);
%  mesh(X,Y,(U-Ue)); hold on; 
   mesh(X,Y,(U)); hold on; drawnow
   emax = max(max(abs(U-Ue)));
   Emax = max(emax,Emax);
end;
[E nex ney Emax 8*Emax]
