hdr

%
%  USAGE:
%
%   for kk=2:6; nel=2^kk; fem_box; end;
%




nex=nel; ney=nel;  % nel x nel squares, each w/ two triangles

E=2*nex*ney; % Number of triangles;
nv=6;        % Quadratic triangles.
nv=3;        % Linear triangles.

if nv==3; nxp=1*nex+1; nyp=1*ney+1; end;
if nv==6; nxp=2*nex+1; nyp=2*ney+1; end;
k=3; if nv==3; k=2; end;

glob=zeros(nv,E); xL=glob; yL=glob;

e=0;
for ey=1:ney; for ex=1:nex; 
   i0 = (ex-1)-1; j0 = (ey-1)-1;

   e=e+1;         % LOWER TRIANGLE; (verts, then edges, cclockwise)
     glob(1,e)=i0+1 + nxp*(j0+1);  xL(1,e)=i0+1; yL(1,e)=j0+1;
     glob(2,e)=i0+k + nxp*(j0+1);  xL(2,e)=i0+k; yL(2,e)=j0+1;
     glob(3,e)=i0+1 + nxp*(j0+k);  xL(3,e)=i0+1; yL(3,e)=j0+k;
   e=e+1;         % UPPER TRIANGLE; (verts, then edges, cclockwise)
     glob(1,e)=i0+1 + nxp*(j0+k);  xL(1,e)=i0+1; yL(1,e)=j0+k;
     glob(2,e)=i0+k + nxp*(j0+1);  xL(2,e)=i0+k; yL(2,e)=j0+1;
     glob(3,e)=i0+k + nxp*(j0+k);  xL(3,e)=i0+k; yL(3,e)=j0+k;
end;end;
glob=glob+1;
t=glob';

E =size(t,1);
nv=size(t,2);
nL=E*nv;
nb=max(max(t));  % nbar

hx = 1.0/nex; xL=hx*xL;
hy = 1.0/ney; yL=hy*yL;

p=zeros(nb,2);
for i=1:3; for e=1:E; 
    ig=t(e,i);
    p(ig,1)=xL(i,e);
    p(ig,2)=yL(i,e);
end; end;
    
tmp=zeros(nb,1);
tmp(reshape(t,3*E,1))=1;
nb=sum(tmp);

[AL,BL,Q]=local_fem_mats(p,t);
[maskL,gbdry] = get_maskl(t);

%%% rbdry = sqrt(p(gbdry,1).^2+p(gbdry,2).^2);
%%% ibbox = find(rbdry > 0.41);
%%% ibbox = find(rbdry < 0.41);
%%% dbdry = gbdry(ibbox);
%%% gbdry = dbdry;

%%% Set up restriction/permutation matrix to make boundary nodes last

ir=[1:nb]';

n = nb-size(gbdry,1);
ir(gbdry) = ir(gbdry) + 2*nb;
[is,ind]=sort(ir); ind=ind(1:n);
P=speye(nb); P=P(:,ind); R=P';

%%%% Plot a function that is 1 in the interior, 0 on the boundary.

f=ones(n,1);   %% 1 in Interior
fb=R'*f;       %% Extend by 0 to the boundary.

%% hold off; tri=trimesh(t,p(:,1),p(:,2),fb);          %% Surface Plot
%% hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
%% axis equal; 
%% pause(1)


%%% Solve a PDE: -nabla^2 u = f(x,y), with f = 1.0

rhs = sqrt(p(:,1).^2+p(:,2).^2);
rhs = (2*pi*pi)*sin(pi*p(:,1)).*sin(pi*p(:,2));
rhs = rhs(reshape(t,3*E,1));   %% Here, a continuous function of x and y
rhs = reshape(rhs,E,3); rhs=rhs'; fL=reshape(rhs,3*E,1);

exct = fL./(2*pi*pi);
count= Q'*ones(3*E,1);
exct = (Q'*exct)./count;

Ab = Q'*AL*Q; A = R*Ab*R';
Bb = Q'*BL*Q; B = R*Bb*R';


u  = A \ (R*(Q'*(BL*fL))); ue=u;
ub = R'*u;
eb = exct-ub;  emax=max(max(abs(eb)));

hold off; tri=trimesh(t,p(:,1),p(:,2),ub);          %% Surface Plot
hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
axis equal; 


figure
hold off; tri=trimesh(t,p(:,1),p(:,2),eb./emax);          %% Surface Plot
hold on;  plot(p(gbdry,1),p(gbdry,2),'r.',ms,9);    %% Plot boundary nodes in red.
axis equal; 


disp([nel emax])
