function [maskL,gbdry]=fem_mat(t)   % Identify Domain Boundary points

E=size(t,1);
ng=max(max(t));

etmp=t';  etmp=[etmp; etmp(1,:)];
edge=zeros(6,E);
edge(1:2,:) = etmp(1:2,:);
edge(3:4,:) = etmp(2:3,:);
edge(5:6,:) = etmp(3:4,:);
edge=reshape(edge,2,3*E);

edge=sort(edge,1); edge=edge';

[edge,ind]=sortrows(edge);

nedge=size(edge,1); flag=zeros(nedge,1);

                          %% Mark non-isolated edges with flag=1
for k=1:nedge-1;
   if edge(k,:)==edge(k+1,:); flag(k)=flag(k)+1; flag(k+1)=flag(k+1)+1; end;
end;

flag(ind)=flag;           %% Map edge flags back to original 3xE ordering.
flag=reshape(flag,3,E);


ptr = zeros(2,3);         %% Zero out local mask entries for any isolated edge
ptr(1,1)=1; ptr(2,1)=2;
ptr(1,2)=2; ptr(2,2)=3;
ptr(1,3)=3; ptr(2,3)=1;

maskL=ones(E,3);
for e=1:E; for j=1:3;
    if flag(j,e)==0; maskL(e,ptr(:,j))=0; end;
end; end;



%
%   Share boundary vertices flagged by isolated edges with neighboring elements
%


flag=ones(ng,1);
for e=1:E; for j=1:3;
    g = t(e,j);
    flag(g)=flag(g)*maskL(e,j);
end; end;

gbdry=zeros(ng,1);  nbdry=0;
for e=1:E; for j=1:3;
    g = t(e,j);
    maskL(e,j)=flag(g);
    if flag(g)==0;
       nbdry = nbdry+1;
       gbdry(nbdry)=g;
    end;
end; end;
gbdry=gbdry(1:nbdry); gbdry=unique(gbdry);

